unit ESCmain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, OleCtrls, Chartfx3, Menus, ActnList, VCFI, TeEngine, Series,
  ExtCtrls, TeeProcs, Chart, TeeFunci, StdCtrls, ComCtrls, ImgList, ToolWin,
  Spin;

type

 TESCData =  record
    data    : byte;

 end;



  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    ActionList1: TActionList;
    File1: TMenuItem;
    Exit1: TMenuItem;
    N1: TMenuItem;
    PrintSetup1: TMenuItem;
    Print1: TMenuItem;
    N2: TMenuItem;
    SaveAs1: TMenuItem;
    Open1: TMenuItem;
    N3: TMenuItem;
    o1: TMenuItem;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    Chart1: TChart;
    Series1: TLineSeries;
    Memo1: TMemo;
    OpenDialog1: TOpenDialog;
    StatusBar1: TStatusBar;
    RadioGroup1: TRadioGroup;
    Panel1: TPanel;
    ToolBar1: TToolBar;
    ImageList1: TImageList;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    ActionOpen: TAction;
    ActionSave: TAction;
    ActionUpdate: TAction;
    ActionHelp: TAction;
    SaveDialog1: TSaveDialog;
    ActionExit: TAction;
    ToolButton5: TToolButton;
    ToolButton8: TToolButton;
    PopupMenuChart: TPopupMenu;
    Stop1: TMenuItem;
    Reverce1: TMenuItem;
    NOUSE1: TMenuItem;
    ToolButton4: TToolButton;
    Label1: TLabel;
    SpinEditNull: TSpinEdit;
    procedure Chartfx1ChangeValue(Sender: TObject; dValue: Double;
      nSerie: Smallint; nPoint: Integer; var nRes: Smallint);
    procedure FormCreate(Sender: TObject);
    procedure Chart1ClickSeries(Sender: TCustomChart; Series: TChartSeries;
      ValueIndex: Integer; Button: TMouseButton; Shift: TShiftState; X,
      Y: Integer);
    procedure Chart1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure Chart1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Open1Click(Sender: TObject);
    procedure RadioGroup1Click(Sender: TObject);
    procedure ActionOpenExecute(Sender: TObject);
    procedure ActionSaveExecute(Sender: TObject);
    procedure ActionExitExecute(Sender: TObject);
    procedure ActionUpdateExecute(Sender: TObject);
    procedure Chart1ContextPopup(Sender: TObject; MousePos: TPoint;
      var Handled: Boolean);
    procedure ActionHelpExecute(Sender: TObject);
  private
    { Private declarations }
      t_Series: TChartSeries;
      i_ValueIndex: Integer;
      i_mX, i_mY: Integer;
      d_YValue :Double;
      s_FileName : string;
      i_fillType : integer;


  private
        c_LineBegin,
        c_LineCount,
        i_DataCount: integer;
        s_FileExt : string;
        r_ESCData : array[0..512]  of  TESCData ;
// in data
        c_MaxCount,                 //47
        c_Stop,                     //0
        c_ErrorCount,               //128
        c_Reverce ,                 //64
        c_Break     : integer;      //64



  public
    { Public declarations }
        procedure FillData();
        function GetColor(data : integer):TColor;
        procedure FillDataTime();
        function Chart2ESCData(ChartData : integer) : byte;

  end;
const
 I_ZCOUNT = 130;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.Chartfx1ChangeValue(Sender: TObject; dValue: Double;
  nSerie: Smallint; nPoint: Integer; var nRes: Smallint);
begin
        nRes :=1;
end;


procedure TForm1.FormCreate(Sender: TObject);
var
 t : integer ;
Begin
        c_MaxCount := 43;
        c_Stop     := 0;
        c_ErrorCount:=128;
        c_Break :=64;
        c_Reverce :=64;


	Series1.Clear;
	for t :=  1 to 256 do
		Series1.Add( t, inttostr(t), clTeeColor) ;
       t_Series := nil;
    SpinEditNull.Value := 175;
end;

procedure TForm1.Chart1ClickSeries(Sender: TCustomChart;
  Series: TChartSeries; ValueIndex: Integer; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
     if i_fillType = 2 then begin
        exit;
     end;
   //
 //     Series.Add( Random(100), , clTeeColor) ;
      t_Series:= Series;
      i_ValueIndex:=ValueIndex;
      i_mX :=x; i_mY:=y;
      d_YValue:=t_Series.YValue[i_ValueIndex];

      r_ESCData[i_ValueIndex].data :=Chart2ESCData(trunc(t_Series.YScreenToValue( y)));


end;

procedure TForm1.Chart1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
var
 data : int64;
 dat : double;
begin
//     if i_fillType = 2 then begin
//        exit;
//     end;

     if    t_Series <> nil then
     begin
             data  :=  trunc(t_Series.YScreenToValue( y));

             if i_fillType = 1
             then    begin if (data > 255) or (data < 0 ) then exit; end
             else    begin if (data > 100) or (data < -100 ) then exit; end;

             t_Series.YValue[i_ValueIndex]:= data;
             t_Series.ValueColor[i_ValueIndex]:=GetColor(data);

             r_ESCData[i_ValueIndex].data :=Chart2ESCData(data);


     end;
end;

procedure TForm1.Chart1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
   t_Series := nil;

end;

///////////////////////////////////////////////////////////////////////////////
//
function TForm1.Chart2ESCData(ChartData : integer) : byte;
begin

     if i_fillType = 1 then begin
        result := ChartData;
        exit;
     end;


    exit;


     if (ChartData < 0 ) then begin
        result := (-1)* ChartData * c_MaxCount div 100 + c_Reverce ;
        exit;
     end;

     if (ChartData > 0 ) then begin
        result :=  ChartData * c_MaxCount div 100 ;
        exit;
     end;



end;
///////////////////////////////////////////////////////////////////////////////
//
procedure TForm1.Open1Click(Sender: TObject);
begin
end;
///////////////////////////////////////////////////////////////////////////////
//
function TForm1.GetColor(data : integer):TColor;
begin
     if     i_fillType =1 then
     begin
             if (data < 64) then
                     result := TColor(clGreen);
             if (data > 64)  then
                     result :=TColor(clBlue);
             if (data > 127) then
                     result :=TColor(clBlack);
             if (data = 64) then
                     result := TColor(clRed);
     end else begin
             if (data > 0) then
                     result := TColor(clGreen);
             if (data < 0)  then
                     result :=TColor(clBlue);
             if (data > 127) then
                     result :=TColor(clBlack);
             if (data = 0) then
                     result := TColor(clRed);
     end;
end;
////////////////////////////////////////////////////////////////////////////////
//    0.8   2.2  =  1.4   200 
//   (+ 30+30 -    )
//  1.5  / 7 =  214 
//  0.8  /7 =  114
//  2.2  /7 =  314 (1-59)
//      
//     0 - 100%
//
procedure TForm1.FillDataTime();
var
 i,CenterCount,p,data,ind,dPlus : integer ;
 str:string;
begin
     i_fillType := 2;
     Series1.Clear;
     for i :=  1 to I_ZCOUNT*2 do begin
      str :=  FloatToStrF(i*(1.5/I_ZCOUNT),ffFixed  , 10,2)+'ms' ;
      Series1.AddNull( str);
     end;


     CenterCount := SpinEditNull.Value;
     dPlus := (CenterCount + 100)-255 ;
     for i:= 0 to  i_DataCount-1 do
     begin

        ind := i;
        if i < dPlus  then ind :=255 + i;
        ind := (ind-centerCount)+I_ZCOUNT;
        if ind < 0 then continue;
        if ind > 256 then continue;

        data :=  r_ESCData[i].data ;



             if (data <= c_MaxCount) then
                     data  := data*100 div c_MaxCount

             else if (data > 64)  then
                     data  := -1*((data-c_Reverce)*100 div c_MaxCount)
             else if (data > 127) then
                     data  := 0
             else if (data = 64) then
                     data  := 0;
	     Series1.YValue[ind]:= data ;
         Series1.ValueColor[ind]:=GetColor(data);

     end;





end;
///////////////////////////////////////////////////////////////////////////////
//
procedure TForm1.FillData();
var
 i,p,data : integer ;
begin
     Series1.Clear;
     i_fillType := 1;
     for i:= 0 to  i_DataCount-1 do
     begin
         data :=  r_ESCData[i].data ;
	     p:=Series1.Add( data, inttostr(i), clTeeColor) ;
         Series1.ValueColor[p]:=GetColor(data);
     end;


end;

procedure TForm1.RadioGroup1Click(Sender: TObject);
begin
     if RadioGroup1.ItemIndex = 1 then
     begin
        FillDataTime();
        Chart1.LeftAxis.Title.Caption:=' %';
     end else begin
        FillData();
        Chart1.LeftAxis.Title.Caption:='';

     end;
end;


procedure TForm1.ActionOpenExecute(Sender: TObject);
var
 i,t,p,data,ind,IndB0,IndE0 : integer ;
 str:string;
begin
    OpenDialog1.Execute();
    s_FileName := OpenDialog1.FileName;
    if Length(s_FileName) = 0 then exit;

    Caption := 'ESC400rev ' + s_FileName;
    Memo1.Lines.LoadFromFile(s_FileName);
    s_FileExt :=(s_FileName);
     c_LineBegin := -1;
     ind:=0; IndB0 :=-1;
     for i:= 0 to Memo1.Lines.Count -1 do
     begin
        str := UpperCase(Memo1.Lines[i]);
        str := AnsiDequotedStr(str,'''');
        p := pos('RETLW',str);
        if p>0 then
        begin
            if c_LineBegin <0 then      c_LineBegin := i;
            if t<>0 then t:=i;
//            str:=StringReplace(str,'RETLW',' ',[rfReplaceAll]);
            p:= pos('0X',str);
            if p > 0 then
            begin
                str := copy(str,p,4);
            end else begin
                p:= pos('H''',str);
                str := '0x'+copy(str,p+2,2);

            end;

            data := StrToInt(Trim(str));
            r_ESCData[ind].data := data;
            if data = 0 then begin
             if IndB0 < 0 then IndB0 := Ind;
             IndE0 := ind;
            end;
            ind:=ind+1;
        end;
     end;

     c_LineCount:=ind;
     i_DataCount:=ind;

     SpinEditNull.Value := (IndE0 + IndB0) div 2;
     if SpinEditNull.Value <= 0 then SpinEditNull.Value := 0;  


      RadioGroup1Click(nil);
//      FillData();

end;

procedure TForm1.ActionUpdateExecute(Sender: TObject);
var
 i,p,data,ind : integer ;
 str,hStr:string;
begin
     c_LineBegin := -1;
     ind:=0;
     for i:= 0 to Memo1.Lines.Count -1 do
     begin
        str := UpperCase(Memo1.Lines[i]);
        str := AnsiDequotedStr(str,'''');
        p := pos('RETLW',str);
        if p>0 then
        begin
            if c_LineBegin <0 then      c_LineBegin := i;
//            if t<>0 then t:=i;
//            str:=StringReplace(str,'RETLW',' ',[rfReplaceAll]);
            p:= pos('0X',str);
            if p > 0 then begin
                Delete(str,p,4);
                hStr:='0x'+IntToHex(r_ESCData[ind].data,2);
            end else begin
                p:= pos('H''',str) + 2;
                Delete(str,p,2);
                hStr:=IntToHex(r_ESCData[ind].data,2);

            end;


            Insert(hStr,str,p);


            ind:=ind+1;
            Memo1.Lines[i]:=str;
        end;
     end;

end;

procedure TForm1.ActionSaveExecute(Sender: TObject);
begin
  //  SaveDialog1.DefaultExt := '*.inc';
    SaveDialog1.Execute();
    s_FileName := SaveDialog1.FileName+SaveDialog1.DefaultExt;
    if Length(s_FileName) = 0 then exit;

    Caption := 'ESC400rev ' + s_FileName;
    Memo1.Lines.SaveToFile(s_FileName);

end;

procedure TForm1.ActionExitExecute(Sender: TObject);
begin
    Close;
end;


procedure TForm1.Chart1ContextPopup(Sender: TObject; MousePos: TPoint;
  var Handled: Boolean);
begin
      //
  //  MousePos.X := MousePos.y;      


end;

procedure TForm1.ActionHelpExecute(Sender: TObject);
begin
        MessageDlg('ESC -  V 1.0. Copyright 1986, 2004  AAP',  mtConfirmation, [mbOK], 0);	
end;

end.
